<template>
  <dibs-layout
    layout="export"
    :with-navbar="false"
    :with-synthesis-link="true"
    :alternate="true"
    :page="'export'"
    class="dibs-synthesis"
  >
    <template #aside-header>
      <dibs-elem-back to="/synthesis" />
    </template>
    <template #aside-content> </template>
    <template #content>
      <div class="dibs--export--header">
        <div></div>
        <dibs-input-help @click="print"><dibs-picto-print /></dibs-input-help>
      </div>
      <div class="dibs--export--content">
        <div v-if="me">
          <dl class="dibs-synthesis--aside--data">
            <dt>
              <!-- eslint-disable-next-line vue/no-v-html -->
              <h1 v-html="$t('page.export.title')" />
            </dt>
            <dd>
              {{ $t("commons.date_at") }} {{ $moment().format("DD.MM.YYYY") }}
            </dd>
            <dt class="dibs-synthesis--block--elem">
              {{ $t("page.avs.form.labels.birthdate") }}
            </dt>
            <dd>
              {{ avsInfo.birthDateString }}
            </dd>
            <dt class="dibs-synthesis--block--elem">
              {{ $t("page.avs.form.labels.age") }}
            </dt>
            <dd>
              {{ $t("commons.years_old", age(avsInfo.birthDate)) }}
            </dd>
            <dt class="dibs-synthesis--block--elem">
              {{ $t("page.avs.form.labels.avs") }}
            </dt>
            <dd>{{ avsInfo.navsString }}</dd>
            <template
              v-for="relation in relationships"
              :key="relation.type + '-dt0'"
            >
              <template v-if="relation.type == 'SPOUSE'">
                <dt class="dibs-synthesis--block--elem">
                  {{ $t("page.avs.form.labels.status") }}
                </dt>
                <dd>
                  {{ $t("commons.status.married.neutral") }}
                </dd>
                <dt class="dibs-synthesis--block--elem">
                  {{ $t("page.avs.form.labels.relationship_start") }}
                </dt>
                <dd>
                  {{ relation.startString }}
                </dd>
                <dt class="dibs-synthesis--block--elem">
                  {{ $t("page.avs.form.labels.partner_birth") }}
                </dt>
                <dd>
                  {{ relation.person.birthDateString }}
                </dd>
                <dt class="dibs-synthesis--block--elem">
                  {{ $t("page.avs.form.labels.partner_age") }}
                </dt>
                <dd>
                  {{ $t("commons.years_old", age(relation.person.birthDate)) }}
                </dd>
              </template>
            </template>
            <template
              v-for="(child, id) in children"
              :key="'child-' + id + '-dt'"
            >
              <dt class="dibs-synthesis--block--elem">
                {{ $t("page.avs.form.labels.child") }}&nbsp;{{ id + 1 }} /
                {{ $t("page.avs.form.labels.birthdate") }}
              </dt>
              <dd>{{ child.birthDateString }}</dd>
            </template>
          </dl>
        </div>

        <dibs-utils-push-up size="medium" />
        <div v-if="totalDigest.data.length" class="dibs-synthesis--content">
          <dibs-partials-synthesis-block
            v-if="totalDigest.data.length"
            :strong="true"
            :title="$t('page.synthesis.parts.total.title')"
            :info="$t('page.synthesis.without_change')"
            :info2="totalDigest.data2 ? $t('page.synthesis.with_change') : null"
            :with-help="false"
            :data="totalDigest.data"
            :data2="totalDigest.data2"
          />

          <dibs-partials-synthesis-block
            v-if="avsDigest.data.length"
            :title="$t('page.synthesis.parts.lavs.title')"
            :hide-info="true"
            :info="$t('page.synthesis.without_change')"
            :info2="totalDigest.data2 ? $t('page.synthesis.with_change') : null"
            :with-help="false"
            :data="avsDigest.data"
            :data2="avsDigest.data2"
          />
          <dibs-partials-synthesis-block
            :title="$t('page.synthesis.parts.lpp.title')"
            :with-help="false"
            :hide-info="true"
            :info="$t('page.synthesis.without_change')"
            :info2="totalDigest.data2 ? $t('page.synthesis.with_change') : null"
            :data="
              lppDigest.data && lppDigest.data.length
                ? lppDigest.data
                : [
                    {
                      label: '',
                    },
                  ]
            "
            :data2="lppDigest.data2"
          />
          <dibs-partials-synthesis-block
            :title="$t('page.synthesis.parts.3a.title')"
            :with-help="false"
            :hide-info="true"
            :info="$t('page.synthesis.without_change')"
            :info2="totalDigest.data2 ? $t('page.synthesis.with_change') : null"
            :data="
              pvDigest.data.length
                ? pvDigest.data
                : [
                    {
                      label: '',
                    },
                  ]
            "
            :data2="pvDigest.data2"
            :summary2="pvDigest.summary2"
            :summary="
              pvDigest.summary && pvDigest.summary.label
                ? pvDigest.summary
                : null
            "
          />
        </div>
      </div>
      <div class="dibs-synthesis--block--elem--precision">
        {{ $t("page.export.warning") }}
      </div>
    </template>
  </dibs-layout>
</template>
<script>
import { decompressFromEncodedURIComponent } from "lz-string";
import md5 from "md5";

export default {
  name: "IndexPage",
  layout: "dibs",
  data() {
    return {
      mode: this.$route.query.mode,
      me: null,
      avsInfo: null,
      relationships: [],
      children: [],
      totalDigest: { data: [], data2: null },
      avsDigest: { data: [], data2: null },
      lppDigest: { data: [], data2: null },
      pvDigest: {
        data: [],
        data2: null,
        summary: null,
      },
    };
  },
  mounted() {
    // on récupère les données dans le # de l'url (on enlève le premier string qui est le # en question)
    const compressedString = window.location.hash.substring(1);

    // decompress the input string using LZString
    const decompressedString =
      decompressFromEncodedURIComponent(compressedString);

    let dataJson = JSON.parse(decompressedString);
    if (dataJson.md5) {
      const md5ToBeVerified = dataJson.md5;
      // vérification des données
      if (md5(dataJson.data) !== md5ToBeVerified) {
        throw new Error("Nous n'avons pas pu vérifier la validité des données");
      }
      dataJson = JSON.parse(dataJson.data);
    }

    // désérialiser les données
    const data = dataJson;

    Object.assign(this.$data, data);
  },
  methods: {
    print() {
      window.print();
    },
    age(date) {
      const dob = new Date(date);

      // calculate month difference from current date in time
      const monthDiff = Date.now() - dob.getTime();

      // convert the calculated difference in date format
      const ageDt = new Date(monthDiff);

      // extract year from date
      const year = ageDt.getUTCFullYear();

      // now calculate the age of the user
      const age = Math.abs(year - 1970);

      return age;
    },
  },
};
</script>
